(function() {
  var Promise, Queue, QueuePoison,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Promise = require("bluebird");

  Queue = require("./queue");

  module.exports = QueuePoison = (function(superClass) {
    extend(QueuePoison, superClass);

    function QueuePoison(opts) {
      this.initialize = bind(this.initialize, this);
      QueuePoison.__super__.constructor.call(this, opts);
      this.queueName = this._poisonQueueName(this.queueName);
    }

    QueuePoison.prototype.pushPoison = function() {
      return Promise.resolve();
    };

    QueuePoison.prototype.initialize = function() {
      return this.create(this.queueName).then(this._setQueueUrl);
    };

    return QueuePoison;

  })(Queue);

}).call(this);
